package com.trust.ywx.customer.common.enu;

import java.util.Objects;

/***************************************************************************
 * <pre></pre>
 * @文件名称:  CachannelEnum.java
 * @包   路   径：  cn.org.bjca.ywq.firm.cons
 * @版权所有：北京数字认证股份有限公司 (C) 2018
 *
 * @类描述:
 * @版本: V1.5
 * @创建人： wujunpeng
 * @创建时间：2021年3月9日 下午7:36:58
 *
 * @修改记录：
 **/
public enum CertAlgEnum {
    RSA(1,"RSA"),
    SM2(2,"SM2"),
    ;

    private int code;
    private String name;

    private CertAlgEnum(int code, String name) {
        this.code = code;
        this.name = name;
    }

    // 普通方法
    public static String getName(int code) {
        for (CertAlgEnum t : CertAlgEnum.values()) {
            if (t.getCode() == code) {
                return t.getName();
            }
        }
        return null;
    }

    public static int getCode(String name) {
        for (CertAlgEnum t : CertAlgEnum.values()) {
            if (Objects.equals(t.getName(),name)) {
                return t.getCode();
            }
        }
        return -1;
    }

    public int getCode() {
        return code;
    }

    public String getName() {
        return name;
    }
}
