package com.trust.ywx.customer.common.enu;

/**
 * ************************************************************************
 * <pre></pre>
 *
 * @文件名称: FirmErrEum.java
 * @包 路   径：  cn.org.bjca.ywq.admin.exception
 * @版权所有：北京数字认证股份有限公司 (C) 2016
 * @类描述:
 * @版本: V1.5
 * @创建人： liuchongzhi
 * @创建时间：2016/11/14 9:45
 * <p/>
 * <p/>
 * *************************************************************************
 */

public enum FirmErrEum {
	// 004x000 ~ 004x010
	FIRM_CLIENT_ID_NULL(1400100,"clientId不能为空"),
	FIRM_APP_SECRET_NULL(1400101,"APP_SECRET不能为空"),
	FIRM_NAME_NULL(1400103,"客户名称不能为空"),
	FIRM_PERSON(1400104,"客户联系人不能为空"),
	FIRM_PHONE(1400105,"客户联系方式不能为空"),
	FIRM_CERTAGENCY(1400106,"凭证类型不能为空"),
	CLIENT_ORG_CODE_NULL(1400107,"客户的统一信用代码为空"),

	FIRM_SMS_CUSTOMIZECONTENT_TOOLONG(1400201,"自定义模板短信内容不能超过100个字符"),
	FIRM_NAME_TOO_LONG(1400202,"客户名称超过30位"),
	FIRM_ICON_TOOBIG(1400203,"客户icon不能超过64K"),
	SUPPORT_INFO_TOOLONG(1400204,"实施支持内容及验收标准超长，仅支持最多300字符"),

	FIRM_NAME_CHECK_ERR(1400301,"客户名称已存在")	,
	CLIENTID_CHECK_ERR(1400302,"客户id已存在"),
	CLIENT_ORG_CODE_CHECK_ERR(1400303,"客户的统一信用代码已存在"),


	FIRM_NOT_EXIST(1400401,"客户不存在"),
	FIRM_STATUS_ERR(1400402,"客户状态不正确"),

	FIRM_SUB_DEPART_EXIST_ERR(1500101,"客户下面包含子客户，不能进行删除"),
	FIRM_SYN_ERR(1500201, "操作数据库失败"),
	FIRM_CA_CHANNEL_CHANGE_ERR(1500301,"客户ca渠道不允许更换"),
	FIRM_CA_CHANNEL_ERR(1500302,"客户ca渠道不存在"),

	FIRM_GROUP_FRIM_CHECK_ERR(1500401,"客户组关联关系异常"),
	FIRM_GROUP_ADD_ERR(1500402,"客户组添加失败"),
	FIRM_GROUP_LEADER_MEMBER_ERR(1500403,"客户组添加失败,组员中不能含有组长"),
	FIRM_GROUP_ADD_MEMBER_ERR(1500404,"客户组添加组员失败"),

	NACOS_START_ERROR(2500100,"nacos启动失败"),
	NACOS_ADD_LISTENER_ERROR(2500101,"nacos添加监视器失败"),

	;

	/**
	 * 状态码
	 */
	private int status;

	/**
	 * 消息
	 */
	private String message;

	private FirmErrEum(int status, String message) {
		this.status = status;
		this.message = message;
	}

	public int getStatus() {
		return status;
	}

	public String getMessage() {
		return message;
	}
}
