package com.trust.ywx.customer.common.model;

import com.github.pagehelper.Page;

import java.io.Serializable;
import java.util.List;

/***************************************************************************
 * <pre></pre>
 * @文件名称: PageBean.java
 * @包 路   径：  cn.org.bjca.ywq.common.base.mybatis
 * @版权所有：北京数字认证股份有限公司 (C) 2016
 *
 * @类描述: 分页返回对象(消费者jar使用)
 * @版本: V1.5
 * @创建人： hudan
 * @创建时间：2016年10月26日 上午9:35:49
 *
 * @修改记录：
 ***/
public class PageBean<T> implements Serializable {
    private static final long serialVersionUID = 1814051162533922236L;
    private int pageNum;
    private int pageSize;
    private long total;
    private int pages;
    private List<T> list;

    private boolean isFirstPage;
    private boolean isLastPage;
    private boolean hasPreviousPage;
    private boolean hasNextPage;

    public PageBean(List<T> list) {
        if (list instanceof Page) {
            Page page = (Page) list;
            this.pageNum = page.getPageNum();
            this.pageSize = page.getPageSize();
            this.total = page.getTotal();
            this.pages = page.getPages();

            judgePageBoudary();
        }
        this.list = list;
    }

    public PageBean(List<T> desclist, List orginalList) {
        if (orginalList instanceof Page) {
            Page page = (Page) orginalList;
            this.pageNum = page.getPageNum();
            this.pageSize = page.getPageSize();
            this.total = page.getTotal();
            this.pages = page.getPages();
        }
        this.list = desclist;
    }

    public int getPageNum() {
        return pageNum;
    }

    public void setPageNum(int pageNum) {
        this.pageNum = pageNum;
    }

    public int getPageSize() {
        return pageSize;
    }

    public void setPageSize(int pageSize) {
        this.pageSize = pageSize;
    }

    public long getTotal() {
        return total;
    }

    public void setTotal(long total) {
        this.total = total;
    }

    public int getPages() {
        return pages;
    }

    public void setPages(int pages) {
        this.pages = pages;
    }

    public List<T> getList() {
        return list;
    }

    public void setList(List<T> list) {
        this.list = list;
    }

    private void judgePageBoudary()
        /*     */ {
        /* 188 */
        this.isFirstPage = (this.pageNum == 1);
        /* 189 */
        this.isLastPage = (this.pageNum == this.pages);
        /* 190 */
        this.hasPreviousPage = (this.pageNum > 1);
        /* 191 */
        this.hasNextPage = (this.pageNum < this.pages);
        /*     */
    }

    @Override
    public String toString() {
        return "PageBean [pageNum=" + pageNum + ", pageSize=" + pageSize + ", total=" + total + ", pages=" + pages
                + ", isFirstPage=" + isFirstPage + ", isLastPage=" + isLastPage + ", hasPreviousPage=" + hasPreviousPage
                + ", hasNextPage=" + hasNextPage + "]";
    }

}
