package com.trust.ywx.customer.common.model.manager.request;

import lombok.Data;

import java.io.Serializable;

/**
 * <pre></pre>
 *
 * @文件名称： FirmPropertyModel.java
 * @包 路  径： com.trust.ywx.customer.common.model
 * @Copyright：北京数字医信责任有限公司 (C) 2022 *
 * @Description:
 * @Version: V1.0
 * @Author： hanzhenchao
 * @Date：2022/6/16 16:12
 * @Modify：
 */
@Data
public class FirmPropParam implements Serializable {
    private static final long serialVersionUID = 5143239003740244348L;
    /**
     * 计费模式
     * 0-规则计费 1-异常计费
     * see com.trust.ywx.customer.common.enums.ChargingModeEnum
     */
    private String chargingMode;

    /**
     * 是否需要实施支持
     * 0-否；1-是
     */
    private String techSupport;
    private String techSupportInfo;
    /**
     * 医师产品形态
     * APP:0-否；1-是
     */
    private String doctorProductApp;
    /**
     * 医师产品形态
     * SDK:0-否；1-是
     */
    private String doctorProductSdk;
    /**
     * 公众产品形态
     * SDK；H5
     * see com.trust.ywx.customer.common.enums.PublicProductTypeEnum
     */
    private String publicProductType;

    /**
     * 客户网络类型
     * gateway-实体医院；it-互联网医院
     * see com.trust.ywx.customer.common.enums.NetworkTypeEnum
     */
    private String networkType = "it";

    /**
     * 内控平台名称
     */
    private String hiscaName;

    /**
     * 内控平台logo图片
     */
    private String hiscaLogo;

    /**
     * 内控平台宣传图片
     */
    private String hiscaPublicityPic;

    /**
     * 内控平台回调地址
     */
    private String hiscaCallUrl;

    /**
     * 通信平台版本 --idm不需要维护此版本
     */
    @Deprecated
    private String gatewayVersion;
    /**
     * 内控监控地址
     */
    private String hiscaMonitorUrl;
    /**
     * 通信平台监控地址
     */
    private String gatewayMonitorUrl;

    /**
     * 客户类型
     * 0-普通 1-冠新 2-微医 3-阿里客户
     * see com.trust.ywx.customer.common.enums.FirmModeEnum
     */
    private String firmMode;
//
//    /**
//     * 证书算法 RSA、SM2
//     */
//    private String certAlg;

    /**
     * 客户白名单
     * 0-否；1-是
     * see com.trust.ywx.customer.common.enums.CommonStatusEnum
     */
    private String isFirmWhite;

    /**
     * 是否允许医生挂靠
     * 0-否；1-是
     * see com.trust.ywx.customer.common.enums.CommonStatusEnum
     */
    private String allowUserBind;


    /**
     * 是否在挂靠医院列表里展示
     * see com.trust.ywx.customer.common.enums.CommonStatusEnum
     */
    private String showFirmInBindList;

    /**
     * 审核完成发送短信
     * see com.trust.ywx.customer.common.enums.CommonStatusEnum
     */
    private String smsSend = "1";
    private String smsCustomize;
    private String smsCustomizeContent;

    //-----------------医生签名增强-------------
    /**
     * 拒签
     */
    private String doctorSignReject;
    /**
     * 作废
     */
    private String doctorSignInvalid;
    /**
     * 人脸识别
     */
    private String doctorSignFaceDetect;
    //-----------------医生签名增强 end-------------

    /**
     * 公众号签名增强
     * see com.trust.ywx.customer.common.enums.CommonStatusEnum
     */
    private String publicSignPhoto;

    /**
     * 个人图章样式
     * see  //stamp:默认；stamp1:签章样式1
     * see com.trust.ywx.customer.common.enu.UserStampTypeEnum
     */
    private String userStampType = "0";

//------------------个人图章模式-----------------
    /**
     * 自动设置图章
     * 默认：勾选
     * fixme 目前存放与firm_info表的stamp_type。以后需要迁移到firm_info_extends表
     */
    private String userStampAutoSet = "1";
    /**
     * 图章压缩
     */
    private String userStampCompress;

    /**
     * 图章审核
     */
    private String userStampIsCheck;

    /**
     * app设置图章
     * 默认：勾选
     */
    private String userStampIsAppset = "1";

    //------------------个人图章模式 end-----------------;
    //------------------企业图章模式-----------------;
    /**
     * 厂商图章类型 0 圆章 1 方章
     * 默认：圆章
     * see com.trust.ywx.customer.common.enums.FirmStampEnum
     */
    private String firmStampType = "0";
    /**
     * 厂商图章时间戳 0否 1是
     */
    private String firmStampTS;
    /**
     * 子厂商图章时间戳 0否 1是
     */
    private String firmStampDepartTS;

    /**
     * 个人PDF增加水印
     * 0-否；1-是
     * see com.trust.ywx.customer.common.enums.CommonStatusEnum
     */
    private String personPdfWater;

    /**
     * 附件pdf增加水印
     */
    private String appendPdfWater;

    /**
     * 自动签增强功能 -用户无感知
     */
    private String selfSignInsensitive;

}
