package com.trust.ywx.customer.common.util;

import com.trust.ywx.customer.common.enu.FirmPropEnum;
import com.trust.ywx.customer.common.model.manager.request.FirmPropParam;

import java.util.HashMap;
import java.util.Map;
import java.util.Objects;

/**
 * <pre></pre>
 *
 * @文件名称： FirmPropUtil.java
 * @包 路  径： com.trust.ywx.customer.common.util
 * @Copyright：北京数字医信责任有限公司 (C) 2022 *
 * @Description:
 * @Version: V1.0
 * @Author： hanzhenchao
 * @Date：2022/6/28 19:50
 * @Modify：
 */
public class FirmPropUtil {
//    /**
//     * 对外都是0/1 或者 枚举值
//     *
//     * @param properName
//     * @return
//     */
//    public static String convertShowValue(String properName, String propValue) {
//        if (isYNValue(properName)) {
//            return "Y".equalsIgnoreCase(propValue) ? "1" : "0";
//        }
//        if (isTrueFalseValue(properName)) {
//            return "true".equalsIgnoreCase(propValue) ? "1" : "0";
//        }
//        return propValue;
//    }

    /**
     * 对外都是0/1转换为数据库存储的值
     *
     * @param properName
     * @return
     */
    public static String convertDbValue(String properName, String propValue) {
        if (isYNValue(properName)) {
            return "1".equalsIgnoreCase(propValue) ? "Y" : "N";
        }
        if (isTrueFalseValue(properName)) {
            return "1".equalsIgnoreCase(propValue) ? "true" : "false";
        }
        return propValue;
    }

    public static FirmPropParam convertToDto(Map<String,String> map){
        FirmPropParam propParam = new FirmPropParam();
        for (Map.Entry<String,String> entry : map.entrySet()) {
            if(FirmPropEnum.CHARGING_MODE.getProperName().equals(entry.getKey())){
                propParam.setChargingMode(entry.getValue());
            }else if(FirmPropEnum.TECHPERSON_SUPPORT.getProperName().equals(entry.getKey())){
                propParam.setTechSupport(entry.getValue());
            }else if(FirmPropEnum.TECHPERSON_SUPPORT_INFO.getProperName().equals(entry.getKey())){
                propParam.setTechSupportInfo(entry.getValue());
            }else if(FirmPropEnum.PUBLIC_PRODUCT_TYPE.getProperName().equals(entry.getKey())){
                propParam.setPublicProductType(entry.getValue());
            }else if(FirmPropEnum.DOCTOR_PRODUCT_APP.getProperName().equals(entry.getKey())){
                propParam.setDoctorProductApp(entry.getValue());
            }else if(FirmPropEnum.DOCTOR_PRODUCT_SDK.getProperName().equals(entry.getKey())){
                propParam.setDoctorProductSdk(entry.getValue());
            }else if(FirmPropEnum.NETWORK_TYPE.getProperName().equals(entry.getKey())){
                propParam.setNetworkType(entry.getValue());
            }else if(FirmPropEnum.HISCA_NAME.getProperName().equals(entry.getKey())){
                propParam.setHiscaName(entry.getValue());
            }else if(FirmPropEnum.HISCA_LOGO.getProperName().equals(entry.getKey())){
                propParam.setHiscaLogo(entry.getValue());
            }else if(FirmPropEnum.HISCA_PUBLICITY.getProperName().equals(entry.getKey())){
                propParam.setHiscaPublicityPic(entry.getValue());
            }else if(FirmPropEnum.HISCA_MONITOR_URL.getProperName().equals(entry.getKey())){
                propParam.setHiscaMonitorUrl(entry.getValue());
            }else if(FirmPropEnum.GATEWAY_MONITOR_URL.getProperName().equals(entry.getKey())){
                propParam.setGatewayMonitorUrl(entry.getValue());
            }else if(FirmPropEnum.HISCA_CALL_URL.getProperName().equals(entry.getKey())){
                propParam.setHiscaCallUrl(entry.getValue());
            }else if(FirmPropEnum.FIRM_MODE.getProperName().equals(entry.getKey())){
                propParam.setFirmMode(entry.getValue());
//            }else if(FirmPropEnum.CERT_ALG.getProperName().equals(entry.getKey())){
//                propParam.set(entry.getValue());
//            }else if(FirmPropEnum.CA_CHANNEL.getProperName().equals(entry.getKey())){
//                propParam.set(entry.getValue());
            }else if(FirmPropEnum.FIRM_ALLOW_USER_BIND.getProperName().equals(entry.getKey())){
                propParam.setAllowUserBind(entry.getValue());
            }else if(FirmPropEnum.SMS_SEND.getProperName().equals(entry.getKey())){
                propParam.setSmsSend(entry.getValue());
            }else if(FirmPropEnum.SMS_CUSTOMIZE.getProperName().equals(entry.getKey())){
                propParam.setSmsCustomize(entry.getValue());
            }else if(FirmPropEnum.SMS_CUSTOMIZE_CONTENT.getProperName().equals(entry.getKey())){
                propParam.setSmsCustomizeContent(entry.getValue());
            }else if(FirmPropEnum.REJECT_SIGN.getProperName().equals(entry.getKey())){
                propParam.setDoctorSignReject(entry.getValue());
            }else if(FirmPropEnum.INVALID_SIGN.getProperName().equals(entry.getKey())){
                propParam.setDoctorSignInvalid(entry.getValue());
            }else if(FirmPropEnum.FACE_DETECT.getProperName().equals(entry.getKey())){
                propParam.setDoctorSignFaceDetect(entry.getValue());
            }else if(FirmPropEnum.PUBLIC_SIGN_PHOTO.getProperName().equals(entry.getKey())){
                propParam.setPublicSignPhoto(entry.getValue());
            }else if(FirmPropEnum.USER_STAMP_TYPE.getProperName().equals(entry.getKey())){
                propParam.setUserStampType(entry.getValue());
            }else if(FirmPropEnum.USER_STAMP_IS_CHECK.getProperName().equals(entry.getKey())){
                propParam.setUserStampIsCheck(entry.getValue());
            }else if(FirmPropEnum.USER_STAMP_IS_APPSET.getProperName().equals(entry.getKey())){
                propParam.setUserStampIsAppset(entry.getValue());
            }else if(FirmPropEnum.USER_STAMP_COMPRESS.getProperName().equals(entry.getKey())){
                propParam.setUserStampCompress(entry.getValue());
            }else if(FirmPropEnum.USER_STAMP_AUTO_SET.getProperName().equals(entry.getKey())){
                propParam.setUserStampAutoSet(entry.getValue());
            }else if(FirmPropEnum.FIRM_STAMP_TYPE.getProperName().equals(entry.getKey())){
                propParam.setFirmStampType(entry.getValue());
            }else if(FirmPropEnum.FIRM_STAMP_TS.getProperName().equals(entry.getKey())){
                propParam.setFirmStampTS(entry.getValue());
            }else if(FirmPropEnum.FIRM_DEPART_STAMP_TS.getProperName().equals(entry.getKey())){
                propParam.setFirmStampDepartTS(entry.getValue());
            }else if(FirmPropEnum.PDF_WATER_PERSON.getProperName().equals(entry.getKey())){
                propParam.setPersonPdfWater(entry.getValue());
            }else if(FirmPropEnum.PDF_WATER_APPEND.getProperName().equals(entry.getKey())){
                propParam.setAppendPdfWater(entry.getValue());
            }else if(FirmPropEnum.SELF_SIGN_BY_FIRM.getProperName().equals(entry.getKey())){
                propParam.setSelfSignInsensitive(entry.getValue());
            }
        }

        return propParam;
    }


    public static Map<String, String> convertToDbMap(FirmPropParam propParam) {
        Map<String, String> propMap = new HashMap<>(32);

        propMap.put(FirmPropEnum.CHARGING_MODE.getProperName(), convertDbValue(FirmPropEnum.CHARGING_MODE.getProperName(), propParam.getChargingMode()));
        propMap.put(FirmPropEnum.TECHPERSON_SUPPORT.getProperName(), convertDbValue(FirmPropEnum.TECHPERSON_SUPPORT.getProperName(), propParam.getTechSupport()));
        propMap.put(FirmPropEnum.TECHPERSON_SUPPORT_INFO.getProperName(), convertDbValue(FirmPropEnum.TECHPERSON_SUPPORT_INFO.getProperName(), propParam.getTechSupportInfo()));
        if (null != propParam.getPublicProductType()) {
            propMap.put(FirmPropEnum.PUBLIC_PRODUCT_TYPE.getProperName(), convertDbValue(FirmPropEnum.PUBLIC_PRODUCT_TYPE.getProperName(), propParam.getPublicProductType()));
        }

        propMap.put(FirmPropEnum.DOCTOR_PRODUCT_APP.getProperName(), convertDbValue(FirmPropEnum.DOCTOR_PRODUCT_APP.getProperName(), propParam.getDoctorProductApp()));
        propMap.put(FirmPropEnum.DOCTOR_PRODUCT_SDK.getProperName(), convertDbValue(FirmPropEnum.DOCTOR_PRODUCT_SDK.getProperName(), propParam.getDoctorProductSdk()));

        if (null != propParam.getNetworkType()) {
            propMap.put(FirmPropEnum.NETWORK_TYPE.getProperName(), convertDbValue(FirmPropEnum.NETWORK_TYPE.getProperName(), propParam.getNetworkType()));
        }

//        propMap.put(FirmPropEnum.GATEWAY_VERSION.getProperName(), propParam.getGatewayVersion());
        propMap.put(FirmPropEnum.HISCA_NAME.getProperName(), propParam.getHiscaName());
        propMap.put(FirmPropEnum.HISCA_LOGO.getProperName(), propParam.getHiscaLogo());
        propMap.put(FirmPropEnum.HISCA_PUBLICITY.getProperName(), propParam.getHiscaPublicityPic());
        propMap.put(FirmPropEnum.HISCA_MONITOR_URL.getProperName(), propParam.getHiscaMonitorUrl());
        propMap.put(FirmPropEnum.GATEWAY_MONITOR_URL.getProperName(), propParam.getGatewayMonitorUrl());
        propMap.put(FirmPropEnum.HISCA_CALL_URL.getProperName(), propParam.getHiscaCallUrl());
        propMap.put(FirmPropEnum.FIRM_MODE.getProperName(), convertDbValue(FirmPropEnum.FIRM_MODE.getProperName(), propParam.getFirmMode()));
        propMap.put(FirmPropEnum.FIRM_ALLOW_USER_BIND.getProperName(), convertDbValue(FirmPropEnum.FIRM_ALLOW_USER_BIND.getProperName(), propParam.getAllowUserBind()));
        propMap.put(FirmPropEnum.FIRM_SHOW_INBINDLIST.getProperName(), convertDbValue(FirmPropEnum.FIRM_SHOW_INBINDLIST.getProperName(), propParam.getShowFirmInBindList()));

        if (null != propParam.getSmsSend()) {
            propMap.put(FirmPropEnum.SMS_SEND.getProperName(), convertDbValue(FirmPropEnum.SMS_SEND.getProperName(), propParam.getSmsSend()));
        }
        if (null != propParam.getSmsCustomize()) {
            propMap.put(FirmPropEnum.SMS_CUSTOMIZE.getProperName(), convertDbValue(FirmPropEnum.SMS_CUSTOMIZE.getProperName(), propParam.getSmsCustomize()));
        }
        propMap.put(FirmPropEnum.SMS_CUSTOMIZE_CONTENT.getProperName(), propParam.getSmsCustomizeContent());

        if (null != propParam.getDoctorSignReject()) {
            propMap.put(FirmPropEnum.REJECT_SIGN.getProperName(), convertDbValue(FirmPropEnum.REJECT_SIGN.getProperName(), propParam.getDoctorSignReject()));
        }
        if (null != propParam.getDoctorSignInvalid()) {
            propMap.put(FirmPropEnum.INVALID_SIGN.getProperName(), convertDbValue(FirmPropEnum.INVALID_SIGN.getProperName(), propParam.getDoctorSignInvalid()));
        }
        propMap.put(FirmPropEnum.FACE_DETECT.getProperName(), propParam.getDoctorSignFaceDetect());
        if (null != propParam.getPublicSignPhoto()) {
            propMap.put(FirmPropEnum.PUBLIC_SIGN_PHOTO.getProperName(), convertDbValue(FirmPropEnum.PUBLIC_SIGN_PHOTO.getProperName(), propParam.getPublicSignPhoto()));
        }

        if (null != propParam.getUserStampType()) {
            propMap.put(FirmPropEnum.USER_STAMP_TYPE.getProperName(), propParam.getUserStampType());
        }
        if (null != propParam.getUserStampIsCheck()) {
            propMap.put(FirmPropEnum.USER_STAMP_IS_CHECK.getProperName(), convertDbValue(FirmPropEnum.USER_STAMP_IS_CHECK.getProperName(), propParam.getUserStampIsCheck()));
        }
        if (null != propParam.getUserStampIsAppset()) {
            propMap.put(FirmPropEnum.USER_STAMP_IS_APPSET.getProperName(), convertDbValue(FirmPropEnum.USER_STAMP_IS_APPSET.getProperName(), propParam.getUserStampIsAppset()));
        }
        propMap.put(FirmPropEnum.USER_STAMP_COMPRESS.getProperName(), propParam.getUserStampCompress());
        propMap.put(FirmPropEnum.USER_STAMP_AUTO_SET.getProperName(), propParam.getUserStampAutoSet());
        propMap.put(FirmPropEnum.FIRM_STAMP_TYPE.getProperName(), propParam.getFirmStampType());
        propMap.put(FirmPropEnum.FIRM_STAMP_TS.getProperName(), propParam.getFirmStampTS());
        propMap.put(FirmPropEnum.FIRM_DEPART_STAMP_TS.getProperName(), propParam.getFirmStampDepartTS());
        propMap.put(FirmPropEnum.PDF_WATER_PERSON.getProperName(), propParam.getPersonPdfWater());
        propMap.put(FirmPropEnum.PDF_WATER_APPEND.getProperName(), propParam.getAppendPdfWater());
        propMap.put(FirmPropEnum.SELF_SIGN_BY_FIRM.getProperName(), propParam.getSelfSignInsensitive());

        return propMap;
    }

    /**
     * 判断是否为合法属性
     *
     * @param properName
     * @return
     */
    public static boolean isLegalProp(String properName) {
        for (FirmPropEnum t : FirmPropEnum.values()) {
            if (Objects.equals(t.getProperName(), properName)) {
                return true;
            }
        }
        return false;
    }

    private static boolean isYNValue(String propName) {
        return propName.equals(FirmPropEnum.SMS_SEND.getProperName())
                || propName.equals(FirmPropEnum.SMS_CUSTOMIZE.getProperName())
                || propName.equals(FirmPropEnum.USER_STAMP_IS_CHECK.getProperName());

    }

    private static boolean isTrueFalseValue(String propName) {
        return propName.equals(FirmPropEnum.REJECT_SIGN.getProperName())
                || propName.equals(FirmPropEnum.INVALID_SIGN.getProperName());

    }
}
