package com.trust.ywx.customer.dao.po;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.Arrays;
import lombok.Data;

/**
 * Table: third_firm_info
 */
@Data
public class ThirdFirmInfo implements Serializable {
    /**
     * Table:     third_firm_info
     * Column:    id
     * Nullable:  false
     */
    private Integer id;

    /**
     * 来源；0-北京CA 1-其他
     *
     * Table:     third_firm_info
     * Column:    source
     * Nullable:  false
     */
    private Integer source;

    /**
     * 第三方平台客户id
     *
     * Table:     third_firm_info
     * Column:    third_customer_id
     * Nullable:  false
     */
    private String thirdCustomerId;

    /**
     * 医网信客户id
     *
     * Table:     third_firm_info
     * Column:    client_id
     * Nullable:  false
     */
    private String clientId;

    /**
     * 证书appId
     *
     * Table:     third_firm_info
     * Column:    cert_app_id
     * Nullable:  false
     */
    private String certAppId;

    private static final long serialVersionUID = 1L;

    @Override
    public String toString() {
        StringBuilder sb = new StringBuilder();
        sb.append(getClass().getSimpleName());
        sb.append(" [");
        sb.append("Hash = ").append(hashCode());
        sb.append(", id=").append(id);
        sb.append(", source=").append(source);
        sb.append(", thirdCustomerId=").append(thirdCustomerId);
        sb.append(", clientId=").append(clientId);
        sb.append(", certAppId=").append(certAppId);
        sb.append(", serialVersionUID=").append(serialVersionUID);
        sb.append("]");
        return sb.toString();
    }

    public static ThirdFirmInfo.Builder builder() {
        return new ThirdFirmInfo.Builder();
    }

    public static class Builder {
        private ThirdFirmInfo obj;

        public Builder() {
            this.obj = new ThirdFirmInfo();
        }

        public Builder id(Integer id) {
            obj.setId(id);
            return this;
        }

        public Builder source(Integer source) {
            obj.setSource(source);
            return this;
        }

        public Builder thirdCustomerId(String thirdCustomerId) {
            obj.setThirdCustomerId(thirdCustomerId);
            return this;
        }

        public Builder clientId(String clientId) {
            obj.setClientId(clientId);
            return this;
        }

        public Builder certAppId(String certAppId) {
            obj.setCertAppId(certAppId);
            return this;
        }

        public ThirdFirmInfo build() {
            return this.obj;
        }
    }

    public enum Column {
        id("id", "id", "INTEGER", false),
        source("source", "source", "BIT", false),
        thirdCustomerId("third_customer_id", "thirdCustomerId", "VARCHAR", false),
        clientId("client_id", "clientId", "VARCHAR", false),
        certAppId("cert_app_id", "certAppId", "VARCHAR", false);

        private static final String BEGINNING_DELIMITER = "\"";

        private static final String ENDING_DELIMITER = "\"";

        private final String column;

        private final boolean isColumnNameDelimited;

        private final String javaProperty;

        private final String jdbcType;

        public String value() {
            return this.column;
        }

        public String getValue() {
            return this.column;
        }

        public String getJavaProperty() {
            return this.javaProperty;
        }

        public String getJdbcType() {
            return this.jdbcType;
        }

        Column(String column, String javaProperty, String jdbcType, boolean isColumnNameDelimited) {
            this.column = column;
            this.javaProperty = javaProperty;
            this.jdbcType = jdbcType;
            this.isColumnNameDelimited = isColumnNameDelimited;
        }

        public String desc() {
            return this.getEscapedColumnName() + " DESC";
        }

        public String asc() {
            return this.getEscapedColumnName() + " ASC";
        }

        public static Column[] excludes(Column ... excludes) {
            ArrayList<Column> columns = new ArrayList<>(Arrays.asList(Column.values()));
            if (excludes != null && excludes.length > 0) {
                columns.removeAll(new ArrayList<>(Arrays.asList(excludes)));
            }
            return columns.toArray(new Column[]{});
        }

        public static Column[] all() {
            return Column.values();
        }

        public String getEscapedColumnName() {
            if (this.isColumnNameDelimited) {
                return new StringBuilder().append(BEGINNING_DELIMITER).append(this.column).append(ENDING_DELIMITER).toString();
            } else {
                return this.column;
            }
        }

        public String getAliasedEscapedColumnName() {
            return this.getEscapedColumnName();
        }
    }
}