package com.trust.ywx.customer.service.manager;

import com.fiftyonetrust.common.model.exception.CodeException;
import com.trust.ywx.customer.common.model.manager.request.FirmParam;
import com.trust.ywx.customer.common.model.manager.response.FirmBaseDto;

/**
 * <pre></pre>
 *
 * @文件名称： FirmManagerService.java
 * @包 路  径： com.trust.ywx.customer.service.manager
 * @Copyright：北京数字医信责任有限公司 (C) 2022 *
 * @Description:
 * @Version: V1.0
 * @Author： hanzhenchao
 * @Date：2022/6/15 18:55
 * @Modify：
 */
public interface FirmManagerService {
    /**
     * 初始化客户
     * 返回clientId和appSecret
     *
     * @param clientId
     * @return
     */
    FirmBaseDto init(String clientId);

    /**
     * 添加可信客户
     */
    boolean add(FirmParam param) throws CodeException;

    /**
     * 更新可信客户
     */
    boolean update(FirmParam param) throws CodeException;

    /**
     * 删除可信客户
     *
     * @param clientId
     * @return
     */
    boolean delete(String clientId);


    /**
     * 添加CA渠道客户
     */
    boolean addCaChannelFirm();

    /**
     * 添加客户白名单
     */
    boolean addFirmWhite();
}
