package com.trust.ywx.customer.service.mq;

import com.alibaba.nacos.api.config.ConfigService;
import com.alibaba.nacos.api.config.annotation.NacosValue;
import com.aliyun.openservices.ons.api.PropertyKeyConst;
import com.aliyun.openservices.ons.api.bean.ProducerBean;
import com.trust.ywx.customer.common.nacos.NacosServer;
//import com.trust.ywx.customer.service.mq.config.MqConfig;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;
import org.springframework.core.annotation.Order;

import javax.annotation.Resource;
import java.util.Properties;

@Configuration
public class ProducerClient {

    @Resource
    private NacosServer nacosServer;
//
    @Bean(initMethod = "start", destroyMethod = "shutdown" )
    @Order(100)
    public ProducerBean buildProducer() {
        Properties properties = new Properties();
        properties.setProperty(PropertyKeyConst.AccessKey, nacosServer.getFirmNacosConfig().getAliAccessKey());
        properties.setProperty(PropertyKeyConst.SecretKey, nacosServer.getFirmNacosConfig().getAliSecretKey());
        properties.setProperty(PropertyKeyConst.NAMESRV_ADDR, nacosServer.getFirmNacosConfig().getRocketMqNameServAddr());
        ProducerBean producer = new ProducerBean();
        producer.setProperties(properties);
        return producer;
    }

}
