package com.trust.ywx.customer.service.query;

import com.trust.ywx.customer.common.model.manager.response.FirmBaseDto;
import com.trust.ywx.customer.common.model.manager.response.FirmWithExtendDto;
import com.trust.ywx.customer.common.model.query.request.SearchCrmFirmParam;
import com.trust.ywx.customer.common.model.query.request.SearchFirmParam;
import com.trust.ywx.customer.common.model.query.response.CrmFirmDto;
import com.trust.ywx.customer.common.model.PageBean;

import java.util.List;
import java.util.Map;

/**
 * <pre></pre>
 *
 * @文件名称： FirmQueryService.java
 * @包 路  径： com.trust.ywx.customer.service.query
 * @Copyright：北京数字医信责任有限公司 (C) 2022 *
 * @Description:
 * @Version: V1.0
 * @Author： hanzhenchao
 * @Date：2022/6/14 19:34
 * @Modify：
 */
public interface FirmQueryService {

    //-------------------------可信客户--------------------

    /**
     * 获取可信客户列表 （分页）
     * @param param
     * @return
     */
    PageBean<FirmBaseDto> getList(SearchFirmParam param);

    /**
     * 获取可信客户基本信息
     * @param clientId
     * @return
     */
    FirmBaseDto getBaseByClientId(String clientId);
    /**
     * 获取可信客户详情
     * @param clientId
     * @return
     */
    FirmWithExtendDto getByClientId(String clientId);

    /**
     * 获取客户配置属性集合
     * 主要给customer-client内部使用！
     */
    Map<String,String> getAllProp(String clientId);

    /**
     * 查询客户白名单
     * @param firmName
     * @return
     */
    List<FirmBaseDto> getFirmWhite(String firmName);

    /**
     * 获取CRM<北京CA,...>客户列表
     * @param param
     */
    List<CrmFirmDto> getCrmFirmList(SearchCrmFirmParam param);




}
