package com.trust.ywx.customer;

import com.alibaba.fastjson.JSONObject;
import com.fiftyonetrust.common.model.exception.CodeException;
import com.fiftyonetrust.common.model.param.PageParam;
import com.trust.ywx.customer.common.enu.CaChannelEnum;
import com.trust.ywx.customer.common.enu.CommonStatusEnum;
import com.trust.ywx.customer.common.enu.ProjectStatusEnum;
import com.trust.ywx.customer.common.model.manager.request.FirmParam;
import com.trust.ywx.customer.common.model.manager.response.FirmBaseDto;
import com.trust.ywx.customer.common.model.query.request.SearchFirmParam;
import com.trust.ywx.customer.common.model.PageBean;
import com.trust.ywx.customer.service.manager.FirmManagerService;
import com.trust.ywx.customer.service.query.FirmQueryService;
import lombok.extern.slf4j.Slf4j;
import org.junit.jupiter.api.Test;
import org.springframework.boot.test.context.SpringBootTest;

import javax.annotation.Resource;

/**
 * <pre></pre>
 *
 * @文件名称： FirmServiceTests.java
 * @包 路  径： com.trust.ywx.customer
 * @Copyright：北京数字医信责任有限公司 (C) 2022 *
 * @Description:
 * @Version: V1.0
 * @Author： hanzhenchao
 * @Date：2022/6/20 17:19
 * @Modify：
 */

@Slf4j
@SpringBootTest(classes = Application.class)
public class FirmServiceTests {
    @Resource
    FirmManagerService managerService;
    @Resource
    FirmQueryService queryService;

    @Test
    public void addTest() throws CodeException {
        FirmParam param = new FirmParam();
        param.setClientId("12345");
        param.setAppSecret("123456");
        param.setFirmOrgCode("678910");
        param.setFirmName("莆田医院");
        param.setProjectStatus(ProjectStatusEnum.NORMAL.getCode());
        param.setCaChannel(null);

        param.setTechSupport(CommonStatusEnum.NO.getCode());
        param.setSmsSend(CommonStatusEnum.YES.getCode());
        param.setSmsCustomize(CommonStatusEnum.YES.getCode());
        param.setSmsCustomizeContent("我的短信我做主");
        managerService.add(param);
        System.out.println("success");
    }

    @Test
    public void delTest(){
        managerService.delete("12345");
    }

    @Test
    public void getExtendTest(){
//        queryService.getAllProp("2022062318060473");
        System.out.println(queryService.getAllProp("2022062318060473"));
    }

    @Test
    public void queryListTest(){
        SearchFirmParam param = new SearchFirmParam();
        PageParam pageParam = new PageParam();
        param.setThirdCustomerId("szrzid001");
        pageParam.setPageNo(1);
        pageParam.setPageSize(10);
        PageBean<FirmBaseDto> pageList = queryService.getList(param);
        System.out.println(JSONObject.toJSONString(pageList));
    }
}
