package com.trust.ywx.customer;

import com.fiftyonetrust.common.model.exception.CodeException;
import com.trust.ywx.customer.common.model.manager.request.TempFirmParam;
import com.trust.ywx.customer.common.model.manager.response.TempFirmDto;
import com.trust.ywx.customer.common.model.query.request.SearchTempFirmParam;
import com.trust.ywx.customer.common.model.PageBean;
import com.trust.ywx.customer.service.manager.TempFirmManagerService;
import com.trust.ywx.customer.service.query.TempFirmQueryService;
import lombok.extern.slf4j.Slf4j;
import org.junit.jupiter.api.Test;
import org.springframework.boot.test.context.SpringBootTest;

import javax.annotation.Resource;

/**
 * <pre></pre>
 *
 * @文件名称： FirmServiceTests.java
 * @包 路  径： com.trust.ywx.customer
 * @Copyright：北京数字医信责任有限公司 (C) 2022 *
 * @Description:
 * @Version: V1.0
 * @Author： hanzhenchao
 * @Date：2022/6/20 17:19
 * @Modify：
 */

@Slf4j
@SpringBootTest(classes = Application.class)
public class TempFirmServiceTests {
    @Resource
    TempFirmManagerService managerService;
    @Resource
    TempFirmQueryService tempQueryService;

    @Test
    public void addTest() throws CodeException {
        TempFirmParam param = new TempFirmParam();
        param.setFirmOrgCode("orgCode3");
        param.setFirmName("数字认证推送医院3");
        param.setThirdCustomerId("szrzid003");
        param.setThirdAppId("msspappid003");
        String clientId = managerService.add(param);
        System.out.println("///////////////////////////////////");
        System.out.println(clientId);
        System.out.println("///////////////////////////////////");
    }



    @Test
    public void updateTest() throws CodeException {
        TempFirmParam param = new TempFirmParam();
        param.setClientId("2022062117474932");
        param.setFirmOrgCode("orgCode");
        param.setFirmName("莆田医院3");
        param.setAppIcon("http://url.com");
        param.setFirmPerson("firmPerson");
        param.setFirmEmail("firmEmail");
        param.setFirmPhone("韩振超");
        param.setAgentSaleId("saleId");
        param.setChannelApp(1);
        param.setChannelSdk(1);
        System.out.println(managerService.update(param));
    }

    @Test
    public void auditTest() throws CodeException {
        System.out.println("///////////////////////////////////");
        System.out.println(managerService.audit("2022062318060473"));
        System.out.println("///////////////////////////////////");

    }

    @Test
    public void rejectTest() throws CodeException {
        System.out.println(managerService.reject("2022062117474932"));
    }

    @Test
    public void delTest(){
        System.out.println(managerService.delete("2022062117474932"));
    }

    @Test
    public void listTest(){
        SearchTempFirmParam param = new SearchTempFirmParam();
        PageBean<TempFirmDto> result = tempQueryService.getTempFirmList(param);
        System.out.println(result);
    }
    @Test
    public void getTest(){
        TempFirmDto result = tempQueryService.getTempFirmByClientId("2022062117474932");
        System.out.println("//////////////////////////////////");
        System.out.println(result);
        System.out.println("//////////////////////////////////");
    }
}
